/* $Id: dungeon.h,v 1.18 2010/03/05 00:48:33 oohara Exp $ */

#ifndef __DUNGEON_H__
#define __DUNGEON_H__

#include "world.h"
#include "creature.h"
#include "list-int.h"
#include "object.h"

int distance(int ax, int ay, int bx, int by);
int compare_wait(list_int *p, list_int *q, void *data);
int add_creature_here(world *wp, creature *who, int n);
int add_creature(world *wp, creature *who);
int remove_creature(world *wp, int creature_id);
int creature_is_dead(world *wp, int creature_id);
int add_object_here(world *wp, object *what, int n);
int add_object(world *wp, object *what);
int remove_object(world *wp, int object_id);
int object_is_dead(world *wp, int object_id);
int inventory_is_dead(world *wp, int inventory_id);
int grid_blocks_creature(world *wp, int x, int y);
int grid_has_creature(world *wp, int x, int y);
int grid_blocks_los(world *wp, int x, int y);
int add_log(world *wp, const char *str);

#endif /* not __DUNGEON_H__ */
