/* $Id: list-int.h,v 1.13 2010/03/05 01:21:21 oohara Exp $ */

#ifndef __LIST_INT_H__
#define __LIST_INT_H__

struct _list_int
{
  struct _list_int *prev;
  struct _list_int *next;
  int n;
};
typedef struct _list_int list_int;

list_int *list_int_new(int n);
list_int *list_int_unlink(list_int *p);
void list_int_delete(list_int *p);
list_int *list_int_first(list_int *p);
list_int *list_int_last(list_int *p);
void list_int_delete_all(list_int *p);
list_int *list_int_concat(list_int *p, list_int *q);
list_int *list_int_insert_after(list_int *where, list_int *p);
list_int *list_int_insert_before(list_int *where, list_int *p);
list_int *list_int_append(list_int *p, int n);
list_int *list_int_prepend(list_int *p, int n);
list_int *list_int_merge(list_int *p, list_int *q, void *data,
                         int (*compare)(list_int *, list_int *, void *));
list_int *list_int_sort(list_int *p, void *data,
                        int (*compare)(list_int *, list_int *, void *));
int list_int_length_all(list_int *p);

#endif /* not __LIST_INT_H__ */
