/* $Id: object.c,v 1.6 2010/03/04 07:46:50 oohara Exp $ */

#include <stdio.h>
/* malloc */
#include <stdlib.h>

#include "object.h"

object *
object_new(void)
{
  object *p = NULL;

  p = (object *) malloc(sizeof(object));
  if (p == NULL)
  {
    fprintf(stderr, "object_new: malloc failed\n");
    return NULL;
  }

  p->id = -1;
  p->type = -1;
  p->x = -1;
  p->y = -1;
  p->quantity = -1;

  return p;
}

void
object_delete(object *p)
{
  if (p == NULL)
    return;

  free(p);
  p = NULL;
}
